﻿/*
Mouth Corder ver2.1
2013/01/10 dA-tools  Shinichi Matsumi

目的： 音声からダイアログシートを製作。口パク合わせ。
手順： 連番の口パクファイルを用意
    そのレイヤーを選択して「set up」ボタンを押す	
    テキストを選択して「Mark」でレイヤーマーカー＋セリフをセット
    口パク番号を押して設定
    タイム・リマップキーをT-sheetにペースト、またはMovieで書き出す、
	
	*/
var myLayer;
var selItem;
function settingDlg(){ //Setting Dialog

//--------------------------
	var dlg = new Window('palette', "MouthCorder",ve2ae(200,200,386-4,210-30));//dialog//palette
		dlg.pnlOrg = dlg.add("panel",ve2ae(4,4,65,170));
		with(dlg.pnlOrg){
			rbM01=add("radiobutton",ve2ae(10,13,50,24),"閉じ");
			rbM02=add("radiobutton",ve2ae(10,38,50,24),"あ");
			rbM03=add("radiobutton",ve2ae(10,63,50,24),"い");
			rbM04=add("radiobutton",ve2ae(10,88,50,24),"う");
			rbM05=add("radiobutton",ve2ae(10,113,50,24),"え");
			rbM06=add("radiobutton",ve2ae(10,138,50,24),"お");
			}
		with(dlg){
			btnDel=dlg.add('button',ve2ae(75,5,40,26),"Del");
			btnLoadTxt=dlg.add('button',ve2ae(125,5,40,26),"Load");
			btnSelect=dlg.add('button',ve2ae(335,5,40,26),"Mark");
			btnNext1=dlg.add('button',ve2ae(125,35,40,26),'>');
			btnNext2=dlg.add('button',ve2ae(125,65,40,26),'>>');
			btnNext3=dlg.add('button',ve2ae(125,95,40,26),'>>>');
			btnRe1=dlg.add('button',ve2ae(75,35,40,26),'<');
			btnRe2=dlg.add('button',ve2ae(75,65,40,26),'<<');
			btnRe3=dlg.add('button',ve2ae(75,95,40,26),'<<<');
			}
	
	etxtDlg=dlg.add("edittext",ve2ae(170,34,205,140), "",{multiline:true});
		
	btnSetLayer=dlg.add('button',ve2ae(170,5,60,26),'Set Up');  //75,130,70,26)

	rbM01.value=true;
	//Event listener
	btnSelect.onClick=function(){
		var Coment=etxtDlg.textselection;    //選択されたテキストを取得。
		var myMarker = new MarkerValue(Coment);
		myLayer.property("Marker").setValueAtTime(selItem.time, myMarker);
		}
	function setRemKey(num){
		myLayer.timeRemap.setValueAtTime(app.project.activeItem.time,num*app.project.activeItem.frameDuration);
		}
	rbM01.onClick =function (){
		setRemKey(0);
		}
		rbM02.onClick =function (){
		setRemKey(1);
		}
		rbM03.onClick =function (){
		setRemKey(2);
		}
		rbM04.onClick =function (){
		setRemKey(3);
		}
		rbM05.onClick =function (){
		setRemKey(4);
		}
		rbM06.onClick =function (){
		setRemKey(5);
		}
	btnSetLayer.onClick=function(){//初期化
		var numLays=selItem.selectedLayers.length;
		if(numLays){
            myLayer=selItem.selectedLayers[0];
            myLayer.timeRemapEnabled = false;//初期化
            myLayer.timeRemapEnabled = true;
            myLayer.timeRemap.removeKey(2);
            myLayer.timeRemap.setInterpolationTypeAtKey(1,KeyframeInterpolationType.HOLD);
            myLayer.outPoint=app.project.activeItem.duration; //compに尺合わせ
			}
		}

	btnDel.onClick=function(){
		var nearKeyId=myLayer.property("timeRemap").nearestKeyIndex(app.project.activeItem.time);
		if (myLayer.property("timeRemap").keyTime(nearKeyId)==app.project.activeItem.time){
			myLayer.timeRemap.removeKey(nearKeyId);
			}
		}

	btnNext1.onClick=function(){
	jumpTo(1);
	}
	btnNext2.onClick=function(){
	jumpTo(2);
	}
	btnNext3.onClick=function(){
	jumpTo(3);
	}
	btnRe1.onClick=function(){
	jumpTo(-1);
	}
	btnRe2.onClick=function(){
	jumpTo(-2);
	}
	btnRe3.onClick=function(){
	jumpTo(-3);
	}
	function jumpTo(koma){
		var newTime=selItem.time+selItem.frameDuration*koma;
		if (newTime<0){
			selItem.time=0;
			}
		else if (newTime>selItem.duration){
			selItem.time=selItem.duration;
			}
		else{
			selItem.time=newTime;
			}
		}
	btnLoadTxt.onClick=function(){
		var fileName = File.openDialog("Select Text file","");
		var myFile = new File(fileName);
		if (myFile.open("r")){
			var myText = "";
			while(!myFile.eof){
				myText = myText + myFile.readln() + String.fromCharCode(13);
			}
		etxtDlg.text=myText;
	}
		}
//------------------------------------
	dlg.show();
}
function setItemLayer(){
	selItem = app.project.activeItem;
	if ((selItem == null) || !(selItem instanceof CompItem)) {
		alert("口パクレイヤーをクリックして選択してください");
		return 0;
	} 
	else {
		var numLays=selItem.selectedLayers.length;
		if(numLays){
			return 1;}
		else{
			alert("口パクレイヤーをクリックして選択してください");
			return 0;
			}
		}	
	}
function ve2ae(left,top,width,height) {
	var right=width+left;
 	var buttom=top+height;
 	return [left,top,right,buttom]
}

if (setItemLayer()){
	settingDlg();
	}

